package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseDao
import com.faraphel.tasks_valider.database.entities.RelationClassPersonEntity

@Dao
interface RelationClassPersonDao : BaseDao<RelationClassPersonEntity> {
    @Query("SELECT * FROM ${RelationClassPersonEntity.TABLE_NAME}")
    override fun getAll(): List<RelationClassPersonEntity>

    /**
     * Get the object from its identifiers
     */
    @Query(
        "SELECT * FROM ${RelationClassPersonEntity.TABLE_NAME} " +
        "WHERE " +
        "class_id = :classId AND " +
        "student_id = :studentId"
    )
    fun getById(classId: Long, studentId: Long): RelationClassPersonEntity?
}
