package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseDao
import com.faraphel.tasks_valider.database.entities.SubjectEntity
import com.faraphel.tasks_valider.database.entities.TaskEntity

@Dao
interface SubjectDao : BaseDao<SubjectEntity> {
    @Query("SELECT * FROM ${SubjectEntity.TABLE_NAME}")
    override fun getAll(): List<SubjectEntity>

    /**
     * Get the object from its identifier
     */
    @Query("SELECT * FROM ${SubjectEntity.TABLE_NAME} WHERE id = :id")
    fun getById(id: Long): SubjectEntity?

    /**
     * Get all the tasks available in a subject
     * @param id the id of the subject
     */
    @Query("SELECT * FROM ${TaskEntity.TABLE_NAME} WHERE subject_id = :id")
    fun getTasks(id: Long): List<TaskEntity>
}
