package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseDao
import com.faraphel.tasks_valider.database.entities.ValidationEntity

@Dao
interface ValidationDao : BaseDao<ValidationEntity> {
    @Query("SELECT * FROM ${ValidationEntity.TABLE_NAME}")
    override fun getAll(): List<ValidationEntity>

    /**
     * Get the object from its identifiers
     */
    @Query(
        "SELECT * FROM ${ValidationEntity.TABLE_NAME} " +
        "WHERE " +
        "teacher_id = :teacherId and " +
        "student_id = :studentId and " +
        "task_id = :taskId"
    )
    fun getById(teacherId: Long, studentId: Long, taskId: Long): ValidationEntity?
}
