package com.faraphel.tasks_valider.database

import com.faraphel.tasks_valider.connectivity.task.session.TaskRole
import com.faraphel.tasks_valider.database.entities.*

fun populateTaskDatabaseTest(database: TaskDatabase) {
    // classes
    val (
        classMiageId,
        classIsriId,
    ) = database.classDao().insert(
        ClassEntity(name="MIAGE"),
        ClassEntity(name="ISRI")
    )

    val classMiage = database.classDao().getById(classMiageId)!!
    val classIrsi = database.classDao().getById(classIsriId)!!

    // persons
    val (
        personBillyId,
        personBobbyId,
        personBettyId,
    ) = database.personDao().insert(
        PersonEntity(
            "Billy", "Bob",
            null,
            "1234",
            TaskRole.STUDENT
        ),
        PersonEntity(
            "Bobby", "Bob",
            null,
            "1234",
            TaskRole.STUDENT
        ),
        PersonEntity(
            "Betty", "Bob",
            null,
            "1234",
            TaskRole.STUDENT
        )
    )

    val personBilly = database.personDao().getById(personBillyId)!!
    val personBobby = database.personDao().getById(personBobbyId)!!
    val personBetty = database.personDao().getById(personBettyId)!!

    // relations class <=> persons
    database.relationClassPersonDao().insert(
        RelationClassPersonEntity(personBobby.id, classMiage.id),
        RelationClassPersonEntity(personBilly.id, classMiage.id),
        RelationClassPersonEntity(personBetty.id, classIrsi.id),
    )

    // subjects
    val (
        subjectAId,
        subjectBId
    ) = database.subjectDao().insert(
        SubjectEntity(
            name="Type A"
        ),
        SubjectEntity(
            name="Type B"
        )
    )

    val subjectA = database.subjectDao().getById(subjectAId)!!
    val subjectB = database.subjectDao().getById(subjectBId)!!

    // tasks
    val (
        taskA1Id,
        taskA2Id,
        taskA3Id,
        taskB1Id,
        taskB2Id,
    ) = database.taskDao().insert(
        TaskEntity(
            title = "Commencer A",
            description = "Description 1",
            order = 1,
            subjectId = subjectA.id,
        ),
        TaskEntity(
            title = "Continuer A",
            description = "Description 2",
            order = 2,
            subjectId = subjectA.id
        ),
        TaskEntity(
            title = "Finir A",
            description = "Description 3",
            order = 3,
            subjectId = subjectA.id
        ),
        TaskEntity(
            title = "Commencer B",
            description = "Description 1",
            order = 1,
            subjectId = subjectB.id,
        ),
        TaskEntity(
            title = "Finir B",
            description = "Description 2",
            order = 2,
            subjectId = subjectB.id,
        )
    )

    val taskA1 = database.taskDao().getById(taskA1Id)!!
    val taskA2 = database.taskDao().getById(taskA2Id)!!
    val taskA3 = database.taskDao().getById(taskA3Id)!!
    val taskB1 = database.taskDao().getById(taskB1Id)!!
    val taskB2 = database.taskDao().getById(taskB2Id)!!
}