package com.faraphel.tasks_valider.ui.screen.communication.internet

import android.app.Activity
import androidx.compose.foundation.layout.Column
import androidx.compose.material3.Button
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.navigation.NavController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController


@Composable
fun CommunicationInternetSelectScreen(activity: Activity) {
    val controller = rememberNavController()

    NavHost(navController = controller, startDestination = "mode") {
        composable("mode") { CommunicationInternetSelectContent(controller) }
        composable("client") { CommunicationInternetClientScreen(activity) }
        composable("server") { CommunicationInternetServerScreen(activity) }
    }
}


@Composable
fun CommunicationInternetSelectContent(controller: NavController) {
    Column {
        // client mode
        Button(onClick = { controller.navigate("client") }) { Text("Client") }
        // server mode
        Button(onClick = { controller.navigate("server") }) { Text("Server") }
    }
}
